View Javadoc

    1   /*
    2    * Licensed to the Apache Software Foundation (ASF) under one or more
    3    * contributor license agreements.  See the NOTICE file distributed with
    4    * this work for additional information regarding copyright ownership.
    5    * The ASF licenses this file to You under the Apache License, Version 2.0
    6    * (the "License"); you may not use this file except in compliance with
    7    * the License.  You may obtain a copy of the License at
    8    *
    9    *      http://www.apache.org/licenses/LICENSE-2.0
    10   *
    11   * Unless required by applicable law or agreed to in writing, software
    12   * distributed under the License is distributed on an "AS IS" BASIS,
    13   * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    14   * See the License for the specific language governing permissions and
    15   * limitations under the License.
    16   */
    17
    18  package org.apache.log4j.pattern;
    19
    20  import org.apache.log4j.spi.LoggingEvent;
    21
    22
    23  /**
    24   * Formats a logger name.
    25   *
    26   * @author Ceki G&uuml;lc&uuml;
    27   *
    28   */
    29  public final class LoggerPatternConverter extends NamePatternConverter {
    30    /**
    31     * Singleton.
    32     */
    33    private static final LoggerPatternConverter INSTANCE =
    34      new LoggerPatternConverter(null);
    35
    36    /**
    37     * Private constructor.
    38     * @param options options, may be null.
    39     */
    40    private LoggerPatternConverter(final String[] options) {
    41      super("Logger", "logger", options);
    42    }
    43
    44    /**
    45     * Obtains an instance of pattern converter.
    46     * @param options options, may be null.
    47     * @return instance of pattern converter.
    48     */
    49    public static LoggerPatternConverter newInstance(
    50      final String[] options) {
    51      if ((options == null) || (options.length == 0)) {
    52        return INSTANCE;
    53      }
    54
    55      return new LoggerPatternConverter(options);
    56    }
    57
    58    /**
    59     * {@inheritDoc}
    60     */
    61    public void format(final LoggingEvent event, final StringBuffer toAppendTo) {
    62      final int initialLength = toAppendTo.length();
    63      toAppendTo.append(event.getLoggerName());
    64      abbreviate(initialLength, toAppendTo);
    65    }
    66  }